<%
  Const strAction = "/CODEREUSE/DisplayAdminPage.asp"


  Class MenuItem
      '************** MEMBER VARIABLES *********************
      Private strTableName
      Private strRedirect
      Private strIdentityColumn

      'Hint Dictionary objects
      Private objFormHints
      Private objFKHints
      Private objFormNameHints
      Private objFormDescriptionHints
      '*****************************************************


      '******************* EVENT HANDLERS ******************
      Private Sub Class_Initialize()
        Set objFormHints = Server.CreateObject("Scripting.Dictionary")
        Set objFKHints = Server.CreateObject("Scripting.Dictionary")
        Set objFormNameHints = Server.CreateObject("Scripting.Dictionary")
        Set objFormDescriptionHints = Server.CreateObject("Scripting.Dictionary")
      End Sub

      Private Sub Class_Terminate()
        Set objFormHints = Nothing
        Set objFKHints = Nothing
        Set objFormNameHints = Nothing
        Set objFormDescriptionHints = Nothing
      End Sub
      '*****************************************************


      '****************** LET PROPERTIES *******************
      Public Property Let TableName(str)
         strTableName = str
      End Property

      Public Property Let IdentityColumnHint(strIdentity)
         strIdentityColumn = strIdentity
      End Property

      Public Property Let Redirect(str)
         strRedirect = str
      End Property
      '*****************************************************


      '****************** GET PROPERTIES *******************
      Public Property Get TableName()
         TableName = strTableName
      End Property

      Public Property Get IdentityColumnHint()
         IdentityColumnHint = strIdentityColumn
      End Property

      Public Property Get Redirect()
         Redirect = strRedirect
      End Property

      Public Property Get FormHints()
         Set FormHints = objFormHints
      End Property

      Public Property Get FKHints()
         Set FKHints = objFKHints
      End Property

      Public Property Get FormNameHints()
         Set FormNameHints = objFormNameHints
      End Property

      Public Property Get FormDescriptionHints()
         Set FormDescriptionHints = objFormDescriptionHints
      End Property
      '*****************************************************


      '********************** METHODS **********************
      Public Sub AddFormHint(strName, strValue)
         If objFormHints.Exists(strName) then
            objFormHints(strName) = strValue
         Else
            objFormHints.Add strName, strValue
         End If
      End Sub

      Public Sub AddFKHint(strName, strValue)
         If objFKHints.Exists(strName) then
            objFKHints(strName) = strValue
         Else
            objFKHints.Add strName, strValue
         End If
      End Sub

      Public Sub AddFormNameHint(strName, strValue)
         If objFormNameHints.Exists(strName) then
            objFormNameHints(strName) = strValue
         Else
            objFormNameHints.Add strName, strValue
         End If
      End Sub

      Public Sub AddFormDescriptionHint(strName, strValue)
         If objFormDescriptionHints.Exists(strName) then
            objFormDescriptionHints(strName) = strValue
         Else
            objFormDescriptionHints.Add strName, strValue
         End If
      End Sub
      '*****************************************************
  End Class


  Class AdminPageMenu
      '************** MEMBER VARIABLES *********************
      Private objMenuDict
      Private strConnString
      Private strUserName
      Private strPassword
      '*****************************************************

      '******************* EVENT HANDLERS ******************
      Private Sub Class_Initialize()
         'Initialize objMenuDict
         Set objMenuDict = Server.CreateObject("Scripting.Dictionary")
      End Sub

      Private Sub Class_Terminate()
         Set objMenuDict = Nothing         'Clean up...
      End Sub
      '*****************************************************

      '****************** GET PROPERTIES *******************
      Public Property Get Count()
         Count = objMenuDict.Count
      End Property
      '*****************************************************      

      '****************** LET PROPERTIES *******************
      Public Property Let ConnectionString(str)
         strConnString = str
      End Property

      Public Property Let UserName(str)
         strUserName = str
      End Property

      Public Property Let Password(str)
         strPassword = str
      End Property
      '*****************************************************      


      '********************** METHODS **********************
      Public Sub AddMenuItem(objMenuItem)
         'Add a new MenuItem instance to the objMenuDict Dictionary object
         objMenuDict.Add objMenuItem.TableName, objMenuItem
      End Sub


      Public Function GenerateMenu()
         'This function returns an HTML string containing the Admin. Page Menu
         Dim strResult, strName, objMenuItem, strTmp, objFormHints, _
             objFKHints, objFormNameHints, objFormDescriptionHints

         strResult = "<CENTER>" & vbCrLf
         For Each strName in objMenuDict
            Set objMenuItem = objMenuDict(strName)
            strResult = strResult & "<FORM METHOD=POST ACTION=""" & strAction & """>" & vbCrLf

            '********* Create HIDDEN variables **********
            strResult = strResult & "<INPUT TYPE=HIDDEN NAME=ConnectionString " & _
                            "VALUE=""" & strConnString & """>" & vbCrLf

            strResult = strResult & "<INPUT TYPE=HIDDEN NAME=UserName " & _
                            "VALUE=""" & strUserName & """>" & vbCrLf

            strResult = strResult & "<INPUT TYPE=HIDDEN NAME=Password " & _
                            "VALUE=""" & strPassword & """>" & vbCrLf

            strResult = strResult & "<INPUT TYPE=HIDDEN NAME=TableName " & _
                            "VALUE=""" & objMenuItem.TableName & """>" & vbCrLf

            strResult = strResult & "<INPUT TYPE=HIDDEN NAME=Redirect " & _
                            "VALUE=""" & objMenuItem.Redirect & """>" & vbCrLf

            strResult = strResult & "<INPUT TYPE=HIDDEN NAME=IdentityColumnHint " & _
                            "VALUE=""" & objMenuItem.IdentityColumnHint & """>" & vbCrLf



            Set objFormHints = objMenuItem.FormHints
            Set objFKHints = objMenuItem.FKHints
            Set objFormNameHints = objMenuItem.FormNameHints
            Set objFormDescriptionHints = objMenuItem.FormDescriptionHints

            For Each strTmp in objFormHints
               strResult = strResult & "<INPUT TYPE=HIDDEN NAME=FormHintsName " & _
                             "VALUE=""" & strTmp & """>" & vbCrLf
               strResult = strResult & "<INPUT TYPE=HIDDEN NAME=FormHintsValue " & _
                             "VALUE=""" & objFormHints(strTmp) & """>" & vbCrLf
            Next
            For Each strTmp in objFKHints
               strResult = strResult & "<INPUT TYPE=HIDDEN NAME=FKHintsName " & _
                             "VALUE=""" & strTmp & """>" & vbCrLf
               strResult = strResult & "<INPUT TYPE=HIDDEN NAME=FKHintsValue " & _
                             "VALUE=""" & objFKHints(strTmp) & """>" & vbCrLf
            Next
            For Each strTmp in objFormNameHints
               strResult = strResult & "<INPUT TYPE=HIDDEN NAME=FormNameHintsName " & _
                             "VALUE=""" & strTmp & """>" & vbCrLf
               strResult = strResult & "<INPUT TYPE=HIDDEN NAME=FormNameHintsValue " & _
                             "VALUE=""" & objFormNameHints(strTmp) & """>" & vbCrLf
            Next
            For Each strTmp in objFormDescriptionHints
               strResult = strResult & "<INPUT TYPE=HIDDEN NAME=FormDescriptionHintsName " & _
                             "VALUE=""" & strTmp & """>" & vbCrLf
               strResult = strResult & "<INPUT TYPE=HIDDEN NAME=FormDescriptionHintsValue " & _
                             "VALUE=""" & objFormDescriptionHints(strTmp) & """>" & vbCrLf
            Next

            Set objFormHints = Nothing
            Set objFKHints = Nothing
            Set objFormNameHints = Nothing
            Set objFormDescriptionHints = Nothing
            '********* End Create HIDDEN variables **********


            strResult = strResult & "<B><CODE>" & objMenuItem.TableName & "</CODE>" & _
                                    " Table Administration</B><BR>" & vbCrLf
            strResult = strResult & "<SELECT SIZE=1 NAME=Action>" & vbCrLf & _
                              "<OPTION VALUE=INSERT>Insert a New Record</OPTION>" & vbCrLf & _
                              "<OPTION VALUE=UPDATE>Edit an Existing Record</OPTION>" & vbCrLf & _
                              "<OPTION VALUE=DELETE>Delete an Existing Record</OPTION>" & vbCrLf & _
                              "</SELECT>" & vbCrLf

            strResult = strResult & "<P><INPUT TYPE=SUBMIT VALUE=""  Go!  "">" & vbCrLf

            strResult = strResult & "</FORM><P><HR><P>" & vbCrLf & vbCrLf

            Set objMenuItem = Nothing
         Next
         strResult = strResult & "</CENTER>" & vbCrLf

         GenerateMenu = strResult
      End Function
      '*****************************************************
  End Class
%>